#ifndef __DILLO_FILTER_H__
#define __DILLO_FILTER_H__
/* filter.h written by ksr */

typedef struct DilloFilter {
  size_t ppos;
  int type;
  unsigned char *inbuf;
  size_t inbufsize;
  size_t total_in;
  size_t inpos;
  unsigned char *outbuf;
  size_t outbufsize;
  size_t outpos;
  size_t total_out;

  void *(*malloc)(size_t);
  void *(*realloc)(void *, size_t);
  void (*free)(void *);
  int (*process)(struct DilloFilter *ext, unsigned char **inptr, size_t *insize, unsigned char **outptr, size_t *outsize, int eof);
  void *ext;
  void (*extfree)(void *);
  int flag;
} DilloFilter;


void a_Filter_init(DilloFilter *p);
void a_Filter_set_in(DilloFilter *p, unsigned char *buf, size_t bufsize, size_t newpos);
void a_Filter_append(DilloFilter *p, unsigned char *buf, size_t bufsize);
int a_Filter_process(DilloFilter *p, int eof);
void a_Filter_free(DilloFilter *p);
DilloFilter *a_Filter_get_translate_filter(void *);

#define FILTER_ZLIB
#define FILTER_TRANS

#endif
