/* The source comes from ruby 1.6.5 */
#define	_AUTO		0
#define	_JIS		1
#define	_EUC		2
#define	_SJIS		3
#define	_BINARY		4
#define	_NOCONV		4
#define	_UNKNOWN	_AUTO

/*
 * Character code detection - Algorithm described in:
 * Ken Lunde. `Understanding Japanese Information Processing'
 * Sebastopol, CA: O'Reilly & Associates.
 */

#define INCR do {\
    p++;\
    if (p==pend) return (_UNKNOWN);\
    sequence_counter++;\
    if (sequence_counter % 2 == 1 && *p != 0xa4)\
	sequence_counter = 0;\
    if (6 <= sequence_counter) {\
	sequence_counter = 0;\
	return (_EUC);\
    }\
} while (0)

int guess_encoding(unsigned char *p, int plen)
{
  int sequence_counter = 0;
  unsigned char *pend;

  pend = p + plen;
  if (*p == 0xa4)
    sequence_counter = 1;

  while (p<pend) {
    if (*p == '\033') {
      return _JIS;
    }
    if (*p < '\006' || *p == 0x7f || *p == 0xff) {
      return _BINARY;
    }
    if (0x81 <= *p && *p <= 0x8d) {
      return _SJIS;
    }
    if (0x8f <= *p && *p <= 0x9f) {
      return _SJIS;
    }
    if (*p == 0x8e) {	/* SS2 */
      INCR;
      if ((0x40 <= *p && *p <= 0x7e) ||
	  (0x80 <= *p && *p <= 0xa0) ||
	  (0xe0 <= *p && *p <= 0xfc))
	return _SJIS;
    }
    else if (0xa1 <= *p && *p <= 0xdf) {
      INCR;
      if (0xf0 <= *p && *p <= 0xfe)
	return _EUC;
      if (0xe0 <= *p && *p <= 0xef) {
	while (p < pend && *p >= 0x40) {
	  if (*p >= 0x81) {
	    if (*p <= 0x8d || (0x8f <= *p && *p <= 0x9f)) {
	      return _SJIS;
	    }
	    else if (0xfd <= *p && *p <= 0xfe) {
	      return _EUC;
	    }
	  }
	  INCR;
	}
      }
      else if (*p <= 0x9f) {
	return _SJIS;
      }
    }
    else if (0xf0 <= *p && *p <= 0xfe) {
      return _EUC;
    }
    else if (0xe0 <= *p && *p <= 0xef) {
      INCR;
      if ((0x40 <= *p && *p <= 0x7e) ||
	  (0x80 <= *p && *p <= 0xa0)) {
	return _SJIS;
      }
      if (0xfd <= *p && *p <= 0xfe) {
	return _EUC;
      }
    }
    INCR;
  }
  return _UNKNOWN;
}
