/*
 * File: intrinsic_iconv.h
 *
 * Copyright (c) 2001 ksr <ksr@todo.org>
 *
 * BSD license without the requirement of indicating copyright notice, 
 * but you have to keep it in the source.
 */

#include <stdlib.h>
#include <sys/types.h>

#define intrinsic_iconv_t iconvjp_t    
#define intrinsic_iconv_open iconvjp_open
#define intrinsic_iconv iconvjp
#define intrinsic_iconv_close iconvjp_close
#define intrinsic_iconv_compat iconvjp_compat

typedef struct iconvjp {
  int (*convert)(struct iconvjp *cd, unsigned char **_in, size_t *_insize,
		 unsigned char **_out, size_t *_outsize);
  int state;
  int compat;
} *iconvjp_t;


iconvjp_t iconvjp_open (char *dstset, char *srcset);
void *iconvjp (iconvjp_t cd, char **inptr, size_t *insize, char **outptr, size_t *outsize);
void iconvjp_close(iconvjp_t cd);
void iconvjp_compat(iconvjp_t cd, int flag);
