#include <pthread.h>
#include <process.h>

#ifndef NULL
#define	NULL	0
#endif

/* #define	USE_BEGINTHREADEX */

int pthread_create (pthread_t *thread, const pthread_attr_t *attr, void *(*start)(void *), void *arg)
{
	unsigned long th;
	unsigned thrdaddr;
	if (attr!=NULL) return -1; /* not support attr now */
#ifdef USE_BEGINTHREADEX
	th = _beginthreadex(NULL,start,0 /*default stack size */,arg,0 /* run*/,&thrdaddr);
	if (th==0) return -1;
#else
	th = _beginthread(start,0 /*default stack size */,arg);
	if (th==-1) return -1;
#endif
	*thread = th;
	return 0;
}

int pthread_detach (pthread_t thread)
{
#ifdef USE_BEGINTHREADEX
	if (CloseHandle(thread)) return 0;
	return -1;
#else
	return 0;
#endif
}
