#include <io.h>
#include <fcntl.h>
#include <errno.h>


#ifndef PASCAL
#define PASCAL __stdcall
#endif

#define INVALID_SOCKET (~0)
#define SOCKET_ERROR	(-1)

typedef unsigned long u_long;
typedef unsigned short u_short;
typedef unsigned char u_char;

typedef unsigned int SOCKET;

struct sockaddr {
	u_short sa_family;
	char	sa_data[14];
};

struct in_addr {
	union {
		struct { u_char s_b1,s_b2,s_b3,s_b4; } S_un_b;
		struct { u_short s_w1,s_w2; } S_un_w;
		u_long S_addr;
	} S_un;
#define s_addr  S_un.S_addr
#define s_host  S_un.S_un_b.s_b2
#define s_net   S_un.S_un_b.s_b1
#define s_imp   S_un.S_un_w.s_w2
#define s_impno S_un.S_un_b.s_b4
#define s_lh    S_un.S_un_b.s_b3
};

typedef struct fd_set fd_set;

#define	OPEN_SOCKET(s)	s /*_open_osfhandle(s,O_RDWR|O_BINARY) */
#define	TO_SOCKET(s)	s /*_get_osfhandle(s) */

#if 0
#define	IMPNAME(name)	_imp__##name
#define	FUNC(type,name,args,n) \
extern type (PASCAL *IMPNAME(name)) args; \
type name args

#else

#define	IMPNAME(name)	___##name
#define	FUNC(type,name,args,n) \
static type PASCAL IMPNAME(name) args __attribute__((alias(#name "@" #n))); \
type name args

#endif

typedef unsigned short WORD;
#define WSADESCRIPTION_LEN	256
#define WSASYS_STATUS_LEN	128
typedef struct WSAData {
	WORD	wVersion;
	WORD	wHighVersion;
	char	szDescription[WSADESCRIPTION_LEN+1];
	char	szSystemStatus[WSASYS_STATUS_LEN+1];
	unsigned short	iMaxSockets;
	unsigned short	iMaxUdpDg;
	char * 	lpVendorInfo;
} WSADATA,*LPWSADATA;

int PASCAL WSAStartup(WORD,LPWSADATA);
int PASCAL WSACleanup(void);
int PASCAL WSAGetLastError(void);
int PASCAL ioctlsocket(SOCKET s,long cmd,void *argp);

#define WSABASEERR	10000
#define WSAEINTR	(WSABASEERR+4)
#define WSAEBADF	(WSABASEERR+9)
#define WSAEACCES	(WSABASEERR+13)
#define WSAEFAULT	(WSABASEERR+14)
#define WSAEINVAL	(WSABASEERR+22)
#define WSAEMFILE	(WSABASEERR+24)
#define WSAEWOULDBLOCK	(WSABASEERR+35)
#define WSAEINPROGRESS	(WSABASEERR+36) /* deprecated on WinSock2 */ 
#define WSAEALREADY	(WSABASEERR+37)
#define WSAENOTSOCK	(WSABASEERR+38)
#define WSAEDESTADDRREQ	(WSABASEERR+39)
#define WSAEMSGSIZE	(WSABASEERR+40)
#define WSAEPROTOTYPE	(WSABASEERR+41)
#define WSAENOPROTOOPT	(WSABASEERR+42)
#define WSAEPROTONOSUPPORT	(WSABASEERR+43)
#define WSAESOCKTNOSUPPORT	(WSABASEERR+44)
#define WSAEOPNOTSUPP	(WSABASEERR+45)
#define WSAEPFNOSUPPORT	(WSABASEERR+46)
#define WSAEAFNOSUPPORT	(WSABASEERR+47)
#define WSAEADDRINUSE	(WSABASEERR+48)
#define WSAEADDRNOTAVAIL	(WSABASEERR+49)
#define WSAENETDOWN	(WSABASEERR+50)
#define WSAENETUNREACH	(WSABASEERR+51)
#define WSAENETRESET	(WSABASEERR+52)
#define WSAECONNABORTED	(WSABASEERR+53)
#define WSAECONNRESET	(WSABASEERR+54)
#define WSAENOBUFS	(WSABASEERR+55)
#define WSAEISCONN	(WSABASEERR+56)
#define WSAENOTCONN	(WSABASEERR+57)
#define WSAESHUTDOWN	(WSABASEERR+58)
#define WSAETOOMANYREFS	(WSABASEERR+59)
#define WSAETIMEDOUT	(WSABASEERR+60)
#define WSAECONNREFUSED	(WSABASEERR+61)
#define WSAELOOP	(WSABASEERR+62)
#define WSAENAMETOOLONG	(WSABASEERR+63)
#define WSAEHOSTDOWN	(WSABASEERR+64)
#define WSAEHOSTUNREACH	(WSABASEERR+65)
#define WSAENOTEMPTY	(WSABASEERR+66)
#define WSAEPROCLIM	(WSABASEERR+67)
#define WSAEUSERS	(WSABASEERR+68)
#define WSAEDQUOT	(WSABASEERR+69)
#define WSAESTALE	(WSABASEERR+70)
#define WSAEREMOTE	(WSABASEERR+71)
#define WSAEDISCON	(WSABASEERR+101)
#define WSASYSNOTREADY	(WSABASEERR+91)
#define WSAVERNOTSUPPORTED	(WSABASEERR+92)
#define WSANOTINITIALISED	(WSABASEERR+93)
#define WSAHOST_NOT_FOUND	(WSABASEERR+1001)
#define WSATRY_AGAIN	(WSABASEERR+1002)
#define WSANO_RECOVERY	(WSABASEERR+1003)
#define WSANO_DATA	(WSABASEERR+1004)
#define WSANO_ADDRESS	WSANO_DATA

static void set_err(void)
{
	int herr = WSAGetLastError();
	switch(herr){
	case WSAEINTR: herr = EINTR; break;
	case WSAEBADF: herr = EBADF; break;
	case WSAEACCES: herr = EACCES; break;
	case WSAEFAULT: herr = EFAULT; break;
	case WSAEINVAL: herr = EINVAL; break;
	case WSAEMFILE: herr = EMFILE; break;
	}
	errno = herr;
}

//static inline int seterr(int r) { if (r==0) return r; else { errno = WSAGetLastError(); return -1;} }
static inline int seterr(int r) { if (r) { set_err(); return -1;} else return r; }
static inline int seterrn(int r) { if (r==SOCKET_ERROR) { set_err(); return -1;} else return r; }
static inline void* seterrh(void *r) { if (r==NULL) { set_err(); return NULL;} else return r; }

static int inited;
static void winsock_cleanup(void)
{
	WSACleanup();
}

static void winsock_init(void)
{
	unsigned short version = 0x101;
	WSADATA wsadata;
	WSAStartup(version,&wsadata);
	atexit(winsock_cleanup);
}

#define	CHECK_WINSOCK()	do { if (!inited) { inited=1; winsock_init();} } while(0)

/*
int ioctl(SOCKET s,long cmd,void *argp)
{
	CHECK_WINSOCK();
	return seterr(ioctlsocket(TO_SOCKET(s),cmd,argp));
}
*/

/* closesocket */

FUNC(SOCKET,accept,(SOCKET s,struct sockaddr *addr,int *addrlen),12)
{
	SOCKET r;
	CHECK_WINSOCK();
	r = IMPNAME(accept)(s,addr,addrlen);
	if (r==INVALID_SOCKET) {
		set_err();
		return -1;
	}
	printf("accept %d\n",r);
	return OPEN_SOCKET(r);
}

FUNC(int,bind,(SOCKET s,const struct sockaddr* addr,int addrlen),12)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(bind)(TO_SOCKET(s),addr,addrlen));
}

FUNC(int,connect,(SOCKET s,const struct sockaddr* addr,int addrlen),12)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(connect)(TO_SOCKET(s),addr,addrlen));
}

FUNC(int,getpeername,(SOCKET s,struct sockaddr *addr,int *addrlen),12)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(getpeername)(TO_SOCKET(s),addr,addrlen));
}

FUNC(int,getsockname,(SOCKET s,struct sockaddr *addr,int *addrlen),12)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(getsockname)(TO_SOCKET(s),addr,addrlen));
}

FUNC(int,getsockopt,(SOCKET s, int level, int optname, char *optval, int *optlen),20)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(getsockopt)(TO_SOCKET(s),level,optname,optval,optlen));
}

FUNC(int,listen,(SOCKET s,int backlog),8)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(listen)(TO_SOCKET(s),backlog));
}

FUNC(int,recv,(SOCKET s,char *buf,int len,int flags),16)
{
	CHECK_WINSOCK();
	return seterrn(IMPNAME(recv)(TO_SOCKET(s),buf,len,flags));
}

FUNC(int,recvfrom,(SOCKET s,char *buf,int len,int flags,struct sockaddr *addr,int *addrlen),24)
{
	CHECK_WINSOCK();
	return seterrn(IMPNAME(recvfrom)(TO_SOCKET(s),buf,len,flags,addr,addrlen));
}

FUNC(int,send,(SOCKET s,const char *buf,int len,int flags),16)
{
	CHECK_WINSOCK();
	return seterrn(IMPNAME(send)(TO_SOCKET(s),buf,len,flags));
}

FUNC(int,sendto,(SOCKET s,const char *buf,int len,int flags,const struct sockaddr *addr,int addrlen),24)
{
	CHECK_WINSOCK();
	return seterrn(IMPNAME(sendto)(TO_SOCKET(s),buf,len,flags,addr,addrlen));
}

FUNC(int,setsockopt,(SOCKET s,int level,int optname,const char *optval,int optlen),20)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(setsockopt)(TO_SOCKET(s),level,optname,optval,optlen));
}

FUNC(int,shutdown,(SOCKET s,int how),8)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(shutdown)(TO_SOCKET(s),how));
}

FUNC(SOCKET,socket,(int af,int type,int protocol),12)
{
	SOCKET r;
	CHECK_WINSOCK();
	r = IMPNAME(socket)(af,type,protocol);
	if (r==INVALID_SOCKET) {
		set_err();
		return -1;
	}
	printf("sockst %d\n",r);
	return OPEN_SOCKET(r);
}

FUNC(unsigned long,inet_addr,(const char *cp),4)
{
	CHECK_WINSOCK();
	return IMPNAME(inet_addr)(cp);
}

FUNC(char *,inet_ntoa,(struct in_addr in),4)
{
	CHECK_WINSOCK();
	return IMPNAME(inet_ntoa)(in);
}

FUNC(struct hostent *,gethostbyaddr,(const char *addr,int len,int type),12)
{
	CHECK_WINSOCK();
	return seterrh(IMPNAME(gethostbyaddr)(addr,len,type));
}

FUNC(struct hostent *,gethostbyname,(const char *name),4)
{
	CHECK_WINSOCK();
	return seterrh(IMPNAME(gethostbyname)(name));
}

FUNC(struct servent *,getservbyport,(int port,const char *proto),8)
{
	CHECK_WINSOCK();
	return seterrh(IMPNAME(getservbyport)(port,proto));
}

FUNC(struct servent *,getservbyname,(const char *name,const char *proto),8)
{
	CHECK_WINSOCK();
	return seterrh(IMPNAME(getservbyname)(name,proto));
}

FUNC(struct protoent *,getprotobynumber,(int number),4)
{
	CHECK_WINSOCK();
	return seterrh(IMPNAME(getprotobynumber)(number));
}

FUNC(struct protoent *,getprotobyname,(const char *name),4)
{
	CHECK_WINSOCK();
	return	seterrh(IMPNAME(getprotobyname)(name));
}

#if 1
extern __inline__ unsigned long int
__ntohl(unsigned long int x)
{
	__asm__("xchgb %b0,%h0\n\t"	/* swap lower bytes	*/
		"rorl $16,%0\n\t"	/* swap words		*/
		"xchgb %b0,%h0"		/* swap higher bytes	*/
		:"=q" (x)
		: "0" (x));
	return x;
}

extern __inline__ unsigned short int
__ntohs(unsigned short int x)
{
	__asm__("xchgb %b0,%h0"		/* swap bytes		*/
		: "=q" (x)
		:  "0" (x));
	return x;
}

unsigned long ntohl(unsigned long x)
{
	return __ntohl(x);
}

unsigned short ntohs(unsigned short x)
{
	return __ntohs(x);
}

unsigned long htonl(unsigned long x)
{
	return __ntohl(x);
}

unsigned short htons(unsigned short x)
{
	return __ntohs(x);
}
#else

FUNC(u_long,htonl,(u_long hostlong),4)
{
	CHECK_WINSOCK();
	return IMPNAME(htonl)(hostlong);
}

FUNC(u_long,ntohl,(u_long netlong),4)
{
	CHECK_WINSOCK();
	return IMPNAME(ntohl)(netlong);
}

FUNC(u_short,htons,(u_short hostshort),4)
{
	CHECK_WINSOCK();
	return IMPNAME(htons)(hostshort);
}

FUNC(u_short,ntohs,(u_short netshort),4)
{
	CHECK_WINSOCK();
	return IMPNAME(ntohs)(netshort);
}
#endif

FUNC(int,gethostname,(char *name,int namelen),8)
{
	CHECK_WINSOCK();
	return seterr(IMPNAME(gethostname)(name,namelen));
}

FUNC(int,select,(int nfds,fd_set *readfds, fd_set *writefds, fd_set *exceptfds,const struct timeval *timeout),20)
{
	CHECK_WINSOCK();
	return seterrn(IMPNAME(select)(nfds,readfds,writefds,exceptfds,timeout));
}
