#include <sys/uio.h>
#include <io.h>
#include <errno.h>

#include <sys/socket.h>

void set_WSA2errno(void)
{
	int herr = WSAGetLastError();
	switch(herr){
	case WSAEINTR: herr = EINTR; break;
	case WSAEBADF: herr = EBADF; break;
	case WSAEACCES: herr = EACCES; break;
	case WSAEFAULT: herr = EFAULT; break;
	case WSAEINVAL: herr = EINVAL; break;
	case WSAEMFILE: herr = EMFILE; break;
	case WSAEWOULDBLOCK: herr = EAGAIN; break;
	}
	errno = herr;
}

int writev(int filedes, const struct iovec *vector, int count)
{
	int rval;
	int ret = 0;
	printf("writev:%d %p %d %d\n",filedes,vector->iov_base,vector->iov_len,count);
	while(count) {
		count--;
		rval = write(filedes,vector->iov_base,vector->iov_len);
		if (rval==-1) {
			if (errno!=EBADF) {
				printf("writev:file:%d:%d:%s\n",filedes,errno,strerror(errno));
				return -1;
			}
			rval=send(filedes,vector->iov_base,vector->iov_len,0);
			if (rval==-1) {
				set_WSA2errno();
				printf("writev:socket:%d:%d:%s\n",filedes,errno,strerror(errno));
				return -1;
			}
		}
		printf("%d:\n",rval);
		ret+=rval;
		vector++;
	}
	return ret;
}
